/*
Class holds details for an Experimental Data object assigned to a particular KeggCompound.
DPL 21.05.2010
 */

public class CompoundData 
{
	String compoundID;	
	boolean present;		// whether present in input list
		
	int len = 0;			// length of condition array
	int[] values;			// array of values
	int[] errors;			// array of errors

	public CompoundData(String compoundID, int len) 
	{
		this.compoundID = compoundID;			
		present = false;	
		
		values = new int[len];
		errors = new int[len];
	}
	
	// -- methods to populate arrays
	
	public void addValue(int val, int pos)
	{
		values[pos] = val;
	}
	
	public void addError(int error, int pos)
	{
		errors[pos] = error;
	}	

	// -- accessor methods ---//
	
	public void setPresent(boolean found) 
	{
		present = found;
	}
	
	public String getCompoundID()
	{
		return compoundID;
	}
	
	public boolean isPresent() 
	{
		return present;
	}
	
	public int[] getValues()
	{
		return values;
	}
	
	public int[] getErrors()
	{
		return errors;
	}
	
	public int getValue(int pos)
	{
		return values[pos];
	}
	
	public int getError(int pos)
	{
		return errors[pos];
	}
	
}