 /*
Class to hold code to write html menus for 
different sections of Metabolomics DB
DPL 07.08.10
*/

import java.io.*;

public class DBMenu
{
	String menuName;				// common html name attribute for 'input submit'
	String [] menuValues;			// array of unique html value attributes for above
	String blank = "";				// invisible spacer item

	public DBMenu(String menuName, String [] menuValues)
	{
		this.menuName = menuName;
		this.menuValues = menuValues;
	}
	
	// prints a menu of all values with selectedValue (current page) inactive and styled differently
	public void writeMenu(String selectedValue, PrintWriter out, String hostURL)
	{
		out.println("<div class=\"topbar\" >");				// open topbar div
		out.println("<form action=\"\" method=\"post\">");	// open form
		out.println("<div>");								// open div within form
		
		for (int i=0; i<menuValues.length; i++)
		{						
			if(menuValues[i].equals(selectedValue))		// selected disabled
			{
				out.println("<input disabled=\"disabled\" type=\"submit\" value=\"" + menuValues[i] + 
									"\" name=\"" + menuName + "\" class=\"selected\" />");													
			}
			else if (menuValues[i].equals(blank))	// blank disabled
			{
				out.println("<input disabled=\"disabled\" type=\"submit\" value=\"" + menuValues[i] + 
									"\" name=\"" + menuName + "\" class=\"selected\" />");				
			}
			else	// enabled
			{
				out.println("<input type=\"submit\" value=\"" + menuValues[i] + 
										"\" name=\"" + menuName + "\" class=\"menu\" />");							
			}			
		}
		
		// help
		out.println("<span class=\"help\"><a href=\"" + hostURL + "/metabHelp/index.html\" onclick=\"openHelp(this.href,'help',645,460); return false;\">Instructions</a></span>");
		
		out.println("</div>");							// close form div
		out.println("</form>");							// close form
		out.println("</div>");							// close topbar div
	}
}

	

	