/* metab.js:  script for Pathos - DPL 23.08.2011 */

// Prevent being framed

	if (top.frames.length!=0)
	{
		top.location=self.document.location;
	}

// Warn IE users that they can't access maps with this browser
function mieWarn()
{
	if (navigator.appName == "Microsoft Internet Explorer")
	{
		alert("The Pathway maps in this application are not\n" + 
		"supported by Microsoft Internet Explorer.\n" +
		"We apologize, but if you need these you should use\n" 
		+ "Firefox, Safari, Chrome, Opera or a related browser.");
	}
}
	
// open url in a centred 'chromeless' window of specified size (resizable and autoscrollbars)

	function openNewWindow(url, w, h) 
	{ 
		openNewWindow(url, w, h, 0)
	}
	
	function openNewWindow(url, w, h, m) 
	{ 
		openNewWindow(url, "Opening", w, h, 0)
	}

	function openNewWindow(url, name, w, h, m) 
	{ 
	   var args = 'width=' + w + ','
	   + 'height=' + h + ','
	   + 'toolbar=0,'
	   + 'location=0,'
	   + 'directories=0,'
	   + 'status=0,'
	   + 'menubar=' + m + ','
	   + 'scrollbars=yes,'
	   + 'resizable=yes';
	 
	   if (parseInt(navigator.appVersion) >= 4)
	   {
	      xposition = (screen.width - w)/2;
	      yposition = (screen.height - h)/2;
	  
	     args += ','
	              + 'screenx=' + xposition + ',' //NN
	              +  'screeny=' + yposition + ',' //NN
	              +  'left=' + xposition + ',' //IE
	              +  'top=' + yposition; //IE
	    }
	
	   window.open(url, name, args);
	}
	
// open url in a popup for motif glossary or Help/Ref
	function openHelp(url, w, h) 
	{ 
		openHelp(url, "Help", w, h);
	}

	function openHelp(url, name, w, h) 
	{ 
	   var args = 'width=' + w + ','
	   + 'height=' + h + ','
	   + 'toolbar=0,'
	   + 'location=0,'
	   + 'directories=0,'
	   + 'status=yes,'
	   + 'menubar=0,'
	   + 'scrollbars=1,'
	   + 'resizable=yes';
	 
	   if (parseInt(navigator.appVersion) >= 4)
	   {
	      xposition = (screen.width - w)/2;
	      yposition = (screen.height - h)/2;
	  
	     args += ','
	              + 'screenx=' + xposition + ',' //NN
	              +  'screeny=' + yposition + ',' //NN
	              +  'left=' + xposition + ',' //IE
	              +  'top=' + yposition; //IE
	    }
	
	   window.open(url, name, args);
	}	

	/* -------------- Javascript to style odd/even table rows -------------- */
	// Simplified from 'Zebra Tables' by David F. Miller 
	// (http://www.alistapart.com/articles/zebratables/)
	// This version ignores the tbody complication and requires colour arguments

  	// Workaround for an IE bug related to element attributes
	function hasClass(obj) 
	{
		 var result = false;
		 if (obj.getAttributeNode("class") != null) 
		 {
		     result = obj.getAttributeNode("class").value;
		 }
		 return result;
	}   

	// 'stripeTable' function taking table id as argument and even and odd hex colours
	function stripeTable(id, evenColor, oddColor) 
	{
		// flag to keep track of whether the current row is odd or even
		var even = false;
		
		// obtain a reference to the desired table 
		var table = document.getElementById(id);
		if (! table) 							// if no table of this id, abort
		{ 
			return; 
		}					
		
		var trs = table.getElementsByTagName("tr");		// find all <tr>s in table...
		for (var i = 0; i < trs.length; i++)	      	// ... and iterate through them
		{
			// avoid rows that have a class attribute or backgroundColor style
			if (! hasClass(trs[i]) && ! trs[i].style.backgroundColor) 
			{     
				var tds = trs[i].getElementsByTagName("td");	 // get all cells in this row...
				for (var j = 0; j < tds.length; j++)  			 // and iterate through them...
				{
					var mytd = tds[j];
					// set appropriate colour, avoiding cells with a class attribute or backgroundColor
					if (! hasClass(mytd) && ! mytd.style.backgroundColor) 
					{
						if(even)
						{
							mytd.style.backgroundColor = evenColor;
						}
						else
						{
							mytd.style.backgroundColor = oddColor;							
						}
					}
				}
			}
			// flip from odd to even, or vice-versa
		    even =  ! even;
		}
	}
	
// JS to create *single* hide/show link the text of which changes in concert
// Must be called in 'onload'
// DPL 05.11.06 after Craig Sailsa and many others
// modified 04.02.10 to allow two or more per page

	var defLinkText = "  show";	// default link text
	var altLinkText = "  hide";	// alternative link text
		// check these ids are actually unique!
	// var visDivID = "visible";		// id of div with vis text to which link ele is added
	// var hidDivID = "hideme";		// id of div with hide/show text
	// var linkID = "expand";			// id for link - generated by js
	
	// creates link on line with vis text if there is div with hidden text
	function createLink(visDivID, hidDivID, linkID)
	{
		if(document.getElementById(visDivID) && document.getElementById(hidDivID))
		{
			var visDiv = document.getElementById(visDivID);		// div to add link ele to
			var hidDiv = document.getElementById(hidDivID);		// div to hide/show
			
			// create 'a' element with js link to hideShow function and append to visible div
			var hsLink = document.createElement("a");
			hsLink.id = linkID;	// provide link with id to ref for text change 
			// construct the ahref as the js hideShow()
			hsLink.href = "javascript:hideShow('" + hsLink.id + "','" + hidDiv.id + "');";
			// add linked text to element and add element to div
			hsLink.appendChild(document.createTextNode(defLinkText));
			visDiv.appendChild(hsLink);
		}
	}
	
	// takes ids of link element and hide/show target div to do hide/show and text change
	function hideShow(link, target)
	{
		// does the hide/show stuff on the target
		theStyle = document.getElementById(target).style;
		var text;	// name of link
		if (theStyle.display == "block")
		{
			theStyle.display = "none";
			newText = defLinkText;
		}
		else
		{
			theStyle.display = "block";
			newText = altLinkText;
		}	
		// get the link element and change its text
		var linkEle = document.getElementById(link);
		linkEle.replaceChild(document.createTextNode(newText), linkEle.firstChild);
	}
	
	// basic hide/show without change in name of link text
	function reveal(target)
	{
		var theStyle = document.getElementById(target).style;
	
		if (theStyle.display == "block")
		{
			theStyle.display = "none";
		}
		else
		{
			theStyle.display = "block";
		}
	}
	
	// basic hide/show all without change in link text 
	// count is number of toggle targets
	var show = true;
	function showAll(count)
	{
		for(var i=0; i<count; i++)
		{
			var target = "toggle" + i;
			var theStyle = document.getElementById(target).style;
		
			if (show == true)
			{
				theStyle.display = "block";
			}
			else
			{
				theStyle.display = "none";
			}
		}
		if(show == true)
		{
			show = false;
		}
		else
		{
			show = true;
		}
	}
	
	// Takes form values to construct pop-up for Kegg map generated by cgi-called web service
	function makeURL(formName)
	{		
		var path = eval("document." + formName + ".path.value");
		var org = eval("document." + formName + ".org.value");
		var compounds = eval("document." + formName + ".compounds.value");		
		var url = "http://localhost/KeggMap.html?path=" + path + "&org=" + org + "&compounds=" + compounds;
		openNewWindow(url, 'Kegg Map', 650, 540); return false;
	}
	
	// checks file selected for upload
	function validateFile(id)
	{
		var theFile = document.getElementById(id); 
		var filePath = theFile.value;
		if(filePath =='') 
		{
			alert("Please select a file to upload!");
			return false;
		}
	}
	
	// Resets form if selections are mutually incompatible
	function identityCheck()
	{
		var bs = document.getElementById("bs");
		var ex = document.getElementById("ex");		
		var u3 = Number(document.getElementById("up3").value);
		var u2 = Number(document.getElementById("up2").value);
		var u1 = Number(document.getElementById("up1").value);		
		var d3 = Number(document.getElementById("down3").value);
		var d2 = Number(document.getElementById("down2").value);
		var d1 = Number(document.getElementById("down1").value);
		
		if(bs.selectedIndex == ex.selectedIndex)
		{
			alert("You have chosen the same conditions for comparison!\nThe form will be reset.");
			document.getElementById("queryEntry").reset();
			return false
		}
		else if(u2 >= u3 || u1 >= u2 || d2 >= d1 || d3 >= d2)
		{
			alert("Incompatible values for colour flagging!\nThe form will be reset.");
			document.getElementById("queryEntry").reset();
			return false		
		}
		else
		{
			return true;
		}
	}
	
	// On and off Rollovers for highlighting degeneracies
	
	function hilite(formula)	// used for onmouseover
	{
		var spanArray = document.getElementsByTagName('span');			
		for(i=0; i<spanArray.length; i++)
		{
			if(spanArray[i].textContent == formula)
			{
				spanArray[i].style.background = '#fc9643';
				spanArray[i].style.padding = "2px";
			}
		}
	}
				
	function lolite(formula)	// used for on mouseout
	{
		var spanArray = document.getElementsByTagName('span');
		for(i=0; i<spanArray.length; i++)
		{
			if(spanArray[i].textContent == formula)
			{
				spanArray[i].style.background = '#ffffff';
				spanArray[i].style.padding = "0px";
			}
		}		
	}